﻿using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Data;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Core.Layers;
using System.Collections;

namespace WC_GanttChartSplitter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.GanttChart;

            GanttDataSource ganttData = new GanttDataSource();

            GanttSeries seriesA = ganttData.Series.Add("Series A");
            GanttItem task1 = seriesA.Items.Add("Task 1");
            task1.Times.Add(DateTime.Now, DateTime.Now.AddDays (5));
            task1.Times[0].ID = 0;
            task1.Times[0].LinkToID = 1;
            task1.Times[0].PercentComplete = 50;
            task1.Times[0].Owner = "Worker A";
            GanttItem task2 = seriesA.Items.Add("Task 2");
            task2.Times.Add(DateTime.Now.AddDays(2),
              DateTime.Now.AddDays(4));
            task2.Times[0].ID = 0;
            task2.Times[0].LinkToID = -1;
            task2.Times[0].PercentComplete = 100;
            task2.Times[0].Owner = "Worker A";

            ultraChart1.DataSource = ganttData;

            ultraChart1.Axis.Y.LineThickness =2 ;
            this.ultraChart1.FillSceneGraph += new Infragistics.UltraChart.Shared.Events.FillSceneGraphEventHandler(this.ChartFillSceneGraph_Event);
            
            MovingAxisTool movingAxisTool = new MovingAxisTool(this.ultraChart1);
            ultraChart1.AddMouseDownTool(movingAxisTool);
        }

        private void ultraChart1_MouseHover(object sender, EventArgs e)
        {

        }

        private void ultraChart1_MouseDown(object sender, MouseEventArgs e)
        {
            
        }

        private void ChartFillSceneGraph_Event(object sender, FillSceneGraphEventArgs e)
        {  
            DateTime[] dateList = new DateTime[] { DateTime.Now, DateTime.Now.AddDays(1) }; ;
            Axis yAxis = e.Grid["Y"] as Axis;
            if (yAxis == null)
            {
                return;
            }
            PrimitiveCollection primitivesToAdd = new PrimitiveCollection();
            int pointCounter = 0;

            foreach (Primitive p in e.SceneGraph)
            {
                Text t = p as Text;

                if  ( ((t != null && t.bounds.Right < yAxis.startPoint.X) && ((t.bounds.Width != 0) && ((t.bounds.Height != 0))))  )
                     
                {
                    // t.bounds.Width + 180 is to draw the box into the Chart Area, 
                    // in order to demonstrate the tool tip shows in chart area not in a column area.

                    Rectangle rect = new Rectangle(t.bounds.Left, t.bounds.Top, t.bounds.Width + 180, t.bounds.Height);

                    Box boxToAdd = new Box(rect);
                    //boxToAdd.PE.FillOpacity = boxToAdd.PE.StrokeOpacity = 0;
                    //boxToAdd.PE.Fill = Color.Transparent;
                    //boxToAdd.PE.Stroke = Color.Transparent;

                    boxToAdd.Caps = PCaps.Tooltip | PCaps.HitTest;
                    boxToAdd.Layer = e.ChartCore.GetChartLayer();                    
                    boxToAdd.Chart = e.ChartCore.ChartType;
                    boxToAdd.Row = boxToAdd.Column = 1000 + pointCounter++;
                    boxToAdd.Value = dateList;

                    primitivesToAdd.Add(boxToAdd);
                }

            }
            e.SceneGraph.AddRange(primitivesToAdd.ToArray());
            

        }

       
    }
}
